<template lang="pug">
b-table( :columns='columns' :data='charges' )
	template( #dates='{ item }' ) <b>{{dayjs(item.createdAt).format("YYYY-MM-DD HH:mm")}}</b> - <b>{{dayjs(item.expiredAt).format("YYYY-MM-DD HH:mm")}}</b>
	template( #status='{ item }' )
		.is-flex.is-align-items-center.is-justify-content-flex-start
			b-tag( :type='tagClass[item.status].class' :light='tagClass[item.status].light' ) {{ $t(`default.t_status.${item.status}`) }}
			//- b-button.ml-3( v-if='item.status == "unresolved"' size="small" type="info" light @click='resolvePayment(item.id)' ) {{ $t("buttons.resolve") }}
	template( #pricing='{ item }' ) {{item.pricing?.local?.amount}} {{item.pricing?.local?.currency}}
	template( #link='{ item }' )
		.is-flex.is-align-items-center.is-justify-content-flex-end
			b-button( node="a" :href='item.paymentLink' target="_blank" type="link" size="small" light )
				span.icon
					i.fa-solid.fa-globe
			b-button.ml-2( v-if='item.code' node="a" :href='`https://beta.commerce.coinbase.com/payments/${item.code}`' target="_blank" type="info" size="small" ) Coinbase
	template( #detail='{ item }' )
		template( v-if='item?.payments?.length' )
			.media.is-align-items-center( v-for='(payment, i) in item.payments' :key='i' )
				.media-left
					figure.image.is-32x32
						img( :src='icon(payment.network)' )
				.media-content.pl-5.is-flex.is-align-items-center.is-justify-content-flex-start
					.is-flex.is-align-items-center.is-justify-content-flex-start
						a.is-underlined( :href='hash(payment)' target="_blank" ) Explorer
						span.icon.ml-2.click( @click='copy(payment.transaction_id)' )
							i.fa-solid.fa-copy
					p.ml-6 
						b {{payment.value?.crypto?.amount || "-"}} {{payment.value?.crypto?.currency || "-"}} 
						|&nbsp;(${{payment.value?.local?.amount}})
					p.ml-6( :class='[ payment.block?.confirmations_accumulated >= payment.block?.confirmations_required ? "has-text-success" : "has-text-danger" ]' )
						span Confirmations:&nbsp;
						span {{ payment.block?.confirmations_accumulated || 0 }} / {{ payment.block?.confirmations_required }}
		p.heading.is-size-5.is-marginless.has-text-grey( v-else ) No payments found
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BTag from "@/components/tags/Tag.vue"

import { transactionTagClass as tagClass } from "@/common/status"
import dayjs from "dayjs"
import { computed } from "vue"
import { useI18n } from "vue-i18n"
import { useToast } from "vue-toastification"

const props = defineProps({
	charges: {
		type: Array,
		default: () => []
	}
})

const toast = useToast()
const { t, locale } = useI18n()

const columns = computed(() => [
	{ field: "id", label: "ID" },
	{ field: "dates", label: "Available" },
	{ field: "status", label: "Status" },
	{ field: "pricing", label: "Amount" },
	{ field: "link" }
])

const hash = computed(() => ({ network, transaction_id }) => `https://blockchair.com/${locale.value}/${network == "dai" ? "etherium" : network}/transaction/${transaction_id}`)
const icon = network => {
	switch(network) {
		case "ethereum":
			return "https://cryptologos.cc/logos/thumbs/ethereum.png?v=022"
		case "usdc":
			return "https://cryptologos.cc/logos/thumbs/usd-coin.png?v=022"
		case "dai":
			return "https://cryptologos.cc/logos/thumbs/multi-collateral-dai.png?v=022"
		case "tether":
			return "https://cryptologos.cc/logos/thumbs/tether.png?v=022"
		case "bitcoincash":
			return "https://cryptologos.cc/logos/thumbs/bitcoin-cash.png?v=022"
		case "dogecoin":
			return "https://cryptologos.cc/logos/thumbs/dogecoin.png?v=022"
		case "litecoin":
			return "https://cryptologos.cc/logos/thumbs/litecoin.png?v=022"
		case "bitcoin":
			return "https://cryptologos.cc/logos/thumbs/bitcoin.png?v=022"
		default:
			return `https://cryptologos.cc/${network}`
	}
}

const copy = async val => {
	if (!val) return

	try {
		await navigator.clipboard.writeText(val)
		toast.success(t("default.copied", { text: val }))
	} catch(err) {
		toast.error(t("default.cannot_copy"))
	}
}
</script>

<style lang="scss" scoped>
	.media-left {
		padding: .5rem;
		background: $white;
		border-radius: 50%;
		box-shadow: inset 0 1px 3px hsl(0deg 0% 86%);
	}

	.image {
		img {
			max-width: 100%;
			width: auto;
			height: 100%;
			margin: 0 auto;
		}
	}

	.media-content {
		border-left: 1px solid rgba(219,219,219,.5);
	}
</style>